
  var cal_ID = 0;

  function CALENDAR(date) {
//========================================================================================================
// Configuration
//========================================================================================================
    this.tFontFace = 'Arial, Helvetica'; // title: font family (CSS-spec, e.g. "Arial, Helvetica")
    this.tFontSize = 14;                 // title: font size (pixels)
    this.tFontColor = '#FFFFFF';         // title: font color
    this.tBGColor = '#304B90';           // title: background color

    this.hFontFace = 'Arial, Helvetica'; // heading: font family (CSS-spec, e.g. "Arial, Helvetica")
    this.hFontSize = 12;                 // heading: font size (pixels)
    this.hFontColor = '#FFFFFF';         // heading: font color
    this.hBGColor = '#304B90';           // heading: background color

    this.dFontFace = 'Arial, Helvetica'; // days: font family (CSS-spec, e.g. "Arial, Helvetica")
    this.dFontSize = 14;                 // days: font size (pixels)
    this.dFontColor = '#000000';         // days: font color
    this.dBGColor = '#FFFFFF';           // days: background color

    this.wFontFace = 'Arial, Helvetica'; // weeks: font family (CSS-spec, e.g. "Arial, Helvetica")
    this.wFontSize = 12;                 // weeks: font size (pixels)
    this.wFontColor = '#FFFFFF';         // weeks: font color
    this.wBGColor = '#304B90';           // weeks: background color

    this.saFontColor = '#0000D0';        // Saturdays: font color
    this.saBGColor = '#F6F6FF';          // Saturdays: background color

    this.suFontColor = '#D00000';        // Sundays: font color
    this.suBGColor = '#FFF0F0';          // Sundays: background color

    this.tdFontColor = '#FFFFFF';        // today: font color
    this.tdBGColor = '#708BD0';          // today: background color

    this.borderColor = '#304B90';        // border color
    this.hilightColor = '#FFFF00';       // hilight color (works only in combination with link)

    this.link = '';                      // page to link to when day is clicked

    this.offset = 1;                     // week start: 0 - 6 (0 = Saturday, 1 = Sunday, 2 = Monday ...)

    // weekdays: must start with Saturday because January 1st of year 1 was a Saturday
    this.weekdays = new Array('Sa', 'Su', 'Mo', 'Tu', 'We', 'Th', 'Fr');

    // months: must start with January
    this.months = new Array('January', 'February', 'March', 'April', 'May', 'June',
                            'July', 'August', 'September', 'October', 'November', 'December');

    // don't change from here
    this.year = 0;
    this.month = 0;
    this.size = 0;
    this.mDays = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

    if(!date) {
      var obj = new Date();
      this.year = obj.getYear();
      if(this.year < 1900) this.year += 1900;
      this.month = obj.getMonth() + 1;
    }
    else {
      var d = date.split('-');
      this.year = d[0];
      this.month = d[1];
    }

//========================================================================================================
// Functions
//========================================================================================================
    this.set_styles = function() {
      cal_ID++;
      var html = '<style> .cssTitle' + cal_ID + ' { ';
      if(this.tFontFace) html += 'font-family: ' + this.tFontFace + '; ';
      if(this.tFontSize) html += 'font-size: ' + this.tFontSize + 'px; ';
      if(this.tFontColor) html += 'color: ' + this.tFontColor + '; ';
      if(this.tBGColor) html += 'background-color: ' + this.tBGColor + '; ';
      html += '} .cssHeading' + cal_ID + ' { ';
      if(this.hFontFace) html += 'font-family: ' + this.hFontFace + '; ';
      if(this.hFontSize) html += 'font-size: ' + this.hFontSize + 'px; ';
      if(this.hFontColor) html += 'color: ' + this.hFontColor + '; ';
      if(this.hBGColor) html += 'background-color: ' + this.hBGColor + '; ';
      html += '} .cssDays' + cal_ID + ' { ';
      if(this.dFontFace) html += 'font-family: ' + this.dFontFace + '; ';
      if(this.dFontSize) html += 'font-size: ' + this.dFontSize + 'px; ';
      if(this.dFontColor) html += 'color: ' + this.dFontColor + '; ';
      if(this.dBGColor) html += 'background-color: ' + this.dBGColor + '; ';
      html += '} .cssWeeks' + cal_ID + ' { ';
      if(this.wFontFace) html += 'font-family: ' + this.wFontFace + '; ';
      if(this.wFontSize) html += 'font-size: ' + this.wFontSize + 'px; ';
      if(this.wFontColor) html += 'color: ' + this.wFontColor + '; ';
      if(this.wBGColor) html += 'background-color: ' + this.wBGColor + '; ';
      html += '} .cssSaturdays' + cal_ID + ' { ';
      if(this.dFontFace) html += 'font-family: ' + this.dFontFace + '; ';
      if(this.dFontSize) html += 'font-size: ' + this.dFontSize + 'px; ';
      if(this.saFontColor) html += 'color: ' + this.saFontColor + '; ';
      if(this.saBGColor) html += 'background-color: ' + this.saBGColor + '; ';
      html += '} .cssSundays' + cal_ID + ' { ';
      if(this.dFontFace) html += 'font-family: ' + this.dFontFace + '; ';
      if(this.dFontSize) html += 'font-size: ' + this.dFontSize + 'px; ';
      if(this.suFontColor) html += 'color: ' + this.suFontColor + '; ';
      if(this.suBGColor) html += 'background-color: ' + this.suBGColor + '; ';
      html += '} .cssToday' + cal_ID + ' { ';
      if(this.dFontFace) html += 'font-family: ' + this.dFontFace + '; ';
      if(this.dFontSize) html += 'font-size: ' + this.dFontSize + 'px; ';
      if(this.tdFontColor) html += 'color: ' + this.tdFontColor + '; ';
      if(this.tdBGColor) html += 'background-color: ' + this.tdBGColor + '; ';
      html += '} .cssHilight' + cal_ID + ' { ';
      if(this.dFontFace) html += 'font-family: ' + this.dFontFace + '; ';
      if(this.dFontSize) html += 'font-size: ' + this.dFontSize + 'px; ';
      if(this.dFontColor) html += 'color: ' + this.dFontColor + '; ';
      if(this.hilightColor) html += 'background-color: ' + this.hilightColor + '; ';
      html += 'cursor: default; ';
      html += '} </style>';

      return html;
    }

    this.leap_year = function(year) {
      return (!(year % 4) && (year < 1582 || year % 100 || !(year % 400))) ? true : false;
    }

    this.get_weekday = function(year, days) {
      var a = days;
      if(year) a += (year - 1) * 365;
      for(var i = 1; i < year; i++) if(this.leap_year(i)) a++;
      if(year > 1582 || (year == 1582 && days >= 277)) a -= 10;
      if(a) a = (a - this.offset) % 7;
      else if(this.offset) a += 7 - this.offset;

      return a;
    }

    this.get_week = function(year, days) {
      var firstWDay = this.get_weekday(year, 0);
      return Math.floor((days + firstWDay) / 7) + (firstWDay <= 3);
    }

    this.table_cell = function(content, cls, date) {
      var size = Math.round(this.size * 1.5);
      var html = '<td align=center width=' + size + ' height=' + size + ' class="' + cls + '"';
      var clsName = cls.toLowerCase();

      if(this.link && content != '&nbsp;' && clsName.indexOf('day') != -1) {
        html += ' onMouseOver="this.className=\'cssHilight' + cal_ID + '\'"';
        html += ' onMouseOut="this.className=\'' + cls + '\'"';
        html += ' onClick="javascript:update(\'' + date + '\')"';
      }
      html += '>' + content + '</td>';

      return html;
    }

    this.table_head = function(title) {
      var html, ind, wDay, i;

      html = '<tr><th colspan=8 class="cssTitle' + cal_ID + '"><b>' + title + '</b></th></tr><tr>';
      for(i = 0; i <= 6; i++) {
        ind = (i + this.offset) % 7;
        wDay = this.weekdays[ind];
        html += this.table_cell(wDay, 'cssHeading' + cal_ID);
      }
      html += this.table_cell('&nbsp;', 'cssHeading' + cal_ID);
      html += '</tr>';

      return html;
    }

    this.create = function() {
      var obj, html, curYear, curMonth, curDay, start, stop, title, daycount,
          inThisMonth, weekNr, wBGColor, wdays, days, ind, cls, content, date, i;

      this.size = (this.hFontSize > this.dFontSize) ? this.hFontSize : this.dFontSize;
      if(this.wFontSize > this.size) this.size = this.wFontSize;

      obj = new Date();
      curYear = obj.getYear();
      if(curYear < 1900) curYear += 1900;
      curMonth = obj.getMonth() + 1;
      curDay = obj.getDate();

      if(this.year < 1 || this.year > 3999) html = '<b>Year must be 1 - 3999!</b>';
      else {
        if(this.leap_year(this.year)) this.mDays[1] = 29;
        for(i = days = 0; i < this.month - 1; i++) days += this.mDays[i];

        start = this.get_weekday(this.year, days);
        stop = this.mDays[this.month-1];

        html = this.set_styles();
        html += '<table border=0 cellspacing=0 cellpadding=0><tr>';
        html += '<td' + (this.borderColor ? ' bgcolor=' + this.borderColor  : '') + '>';
        html += '<table border=0 cellspacing=1 cellpadding=3>';
        title = this.months[this.month-1] + ' ' + this.year;
        html += this.table_head(title);
        daycount = 1;

        if((this.year == curYear) && (this.month == curMonth)) inThisMonth = true;
        else inThisMonth = false;

        weekNr = this.get_week(this.year, days);
        wBGColor = this.wBGColor;

        while(daycount <= stop) {
          html += '<tr>';

          for(i = wdays = 0; i <= 6; i++) {
            ind = (i + this.offset) % 7;
            if(ind == 0) cls = 'cssSaturdays';
            else if(ind == 1) cls = 'cssSundays';
            else cls = 'cssDays';

            if((daycount == 1 && i < start) || daycount > stop) content = '&nbsp;';
            else {
              content = daycount;
              if(inThisMonth && daycount == curDay) cls = 'cssToday';
              else if(this.year == 1582 && this.month == 10 && daycount == 4) daycount = 14;
              daycount++;
              wdays++;
            }
            date = this.year + '-' + this.month + '-' + (daycount - 1);
            html += this.table_cell(content, cls + cal_ID, date);
          }
          if(!weekNr) {
            if(this.year == 1) content = '&nbsp;';
            else if(this.year == 1583) content = 52;
            else content = this.get_week(this.year - 1, 365);
          }
          else if(this.month == 12 && weekNr >= 52 && wdays < 4) content = 1;
          else content = weekNr;
          html += this.table_cell(content, 'cssWeeks' + cal_ID);
          html += '</tr>';
          weekNr++;
        }
        html += '</table></td></tr></table>';
      }
      return html;
    }
  }
